# Øving 06: Observatør-Observert og Delegering
**Øvingsmål**
* Lære hva observatør-observert-teknikken er, dens bruksområder og fordeler
* Lære bruk av delegering for å utføre oppgaver i en klasse

**Øvingskrav**
* Kunne definere og implementere et observatørgrensesnitt
* Kunne la en observert klasse fortelle dens observatører om endringer
* Kunne la en klasse delegere utførelsen av oppgaver til interne objekter

## Dette må du gjøre

Denne øvingen omfatter både [delegeringsteknikken](https://www.ntnu.no/wiki/display/tdt4100/Delegeringsteknikken) og
[observatør-observert-teknikken](https://www.ntnu.no/wiki/pages/viewpage.action?pageId=66879660). Minstekravet for å få øvingen
godkjent er å gjennomføre **mint én** av de fire oppgavene under. Det anbefales derimot på det *sterkeste* å gjøre minst én oppgave
fra hvert av de to temaene, siden dette må til for å dekke hele pensum.

Gjennomfør enten *minst én* av oppgavene om delegering:
* [The Office (ovinger/src/patterns.delegation.office)](./Office.md) (anbefalt)
* [Logger (ovinger/src/patterns.delegation)](./Logger.md)

ELLER *minst én* av oppgavene om observatør-observert-teknikken:
* [StockListener (ovinger/src/patterns.observable)](./StockListener.md)
* [Highscore (ovinger/src/patterns.observable)](./HighscoreList.md)

Oppgavene skal lagres i mappene som er spesifisert i parentes etter oppgavene.

**I tillegg til oppgaven(e) ovenfor skal du levere en tekstfil hvor du gjør kort rede for delegeringsteknikken og observatør-observert-teknikken.**

### Hjelp / mistanke om bugs
Ved spørsmål eller behov for hjelp konsulter studassen din i saltiden hans / hennes. Du kan også oppsøke andre studasser på sal eller legge ut et innlegg på [Piazza](https://piazza.com/).

### Godkjenning
Last opp kildekode på Blackboard innen den angitte innleveringsfristen. Innlevert kode skal demonstreres for en læringsassistent innen én uke etter innleveringsfrist. Se for øvrig Blackboard-sidene for informasjon rundt organisering av øvingsopplegget og det tilhørende øvingsreglementet.
